<?php
namespace controllers;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class MessageController extends \Phalcon\Mvc\Controller
{

    function indexAction($type)
    {
        $data = \message::find(array("type='$type'","order" => 'id'));
        $this->view->setVars([
            'data' => $data,
            'type' => $type
        ]);
    }



    function setAction()
    {
        if($this->request->getPost()){
            $model =  new \message();
            $model->email   = $this->request->getPost('email', 'email');
            $model->comments  = $this->request->getPost('text', 'string');
            $model->type  = $this->request->getPost('type', 'string');
            $model->phone = $this->request->getPost('phone', 'string');
            $model->status  = 0;
            $model->save();
        } else {
            echo "doesn't have any messages ";
        }
        die();
    }


    function addAction()
    {
        $model = array();
        if( $this->request->isPost() )
        {
            $model = new \message();
            $data['request']          = $this->request->getPost('request', 'string', NULL );
            $data['email']           = $this->request->getPost('email', 'email', NULL );
            if( $model->save($data) )
            {
                $this->flash->success( 'Сохранение прошло успешно' );
                return $this->response->redirect([ 'for' => 'index_message' ]);
            }
            else
            {
                $this->flash->error( 'Произошла ошибка во время сохранения.' );
            }
        }
        $this->view->pick( 'message/addEdit' );
        $this->view->setVars([
            'item' => $model,
        ]);

    }

    function deleteAction($id,$type)
    {
        $model = \message::findFirst("id = '$id'");

        if($model instanceof \message) {
            if($model->delete()){
                $this->flash->error( 'Данные успешно удалены' );
                return $this->response->redirect([ 'for' => 'index_message', 'type'=>$type ]);
            } else {
                $this->flash->error( 'Произошла ошибка при попытке удаления' );
                return $this->response->redirect([ 'for' => 'index_message', 'type'=>$type ]);
            }
        }

    }

    function updateAction($id)
    {
        $model = \message::findFirst("id = '$id'");
        $model->status = '1';
        $model->save();
        if( $this->request->isPost() )
        {
            $model->email   = $this->request->getPost('email', 'email');
            $model->comments  = $this->request->getPost('text', 'string');
            $model->type  = $this->request->getPost('type', 'string');
            $model->phone = $this->request->getPost('phone', 'string');
            if( $model->save() )
            {
                $this->flash->success( 'Сохранение прошло успешно' );
                return $this->response->redirect([ 'for' => 'index_request' ]);
            }
            else
            {
                $this->flash->error( 'Произошла ошибка во время сохранения.' );
            }
        }

        $this->view->pick( 'message/addEdit' );
        $this->view->setVars([
            'data' => $model,
        ]);
    }
}