<?php

namespace controllers;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class SeriesOfLettersController extends \Phalcon\Mvc\Controller
{
    public function initialize()
    {
        $this->view->setTemplateAfter('common');
    }

    public function indexAction(){

        $data = \seriesOfLetters::find();

        $this->view->setVars([
            'data' => $data
        ]);
    }


    public function addAction(){
        if( $this->request->isPost() )
        {

            $data['project_id']     = $this->session->get('project-id');
            $data['name']           = $this->request->getPost('name', 'string', NULL );
            $data['status']         = $this->request->getPost('status')?$this->request->getPost('status'):0 ;
            $data['event']          = $this->request->getPost('event' );
            $data['period_val']     = $this->request->getPost('period_val' );
            $data['first_delivery'] = $this->request->getPost('first_delivery' );
            $data['letters']        = implode(',',$data['event']);

            $model = new \seriesOfLetters();
            if( !empty( $data['name'] ))
            {
                if( $model->save( $data ) )
                {
                    $this->flash->success( 'Сохранение прошло успешно' );
                    return $this->response->redirect('series_of_letters/index');
                }
                else
                {
                    $this->flash->error( 'Произошла ошибка во время добавления.' );
                }
            }
        }
        $this->view->pick( 'series_of_letters/addEdit' );
        $this->view->setVars([
            'page' => new \seriesOfLetters(),
            'events' => []
        ]);
    }

    public function deleteAction($id){

        $data = \seriesOfLetters::find("id=$id AND project_id ={$this->session->get('project-id')} ");
        $data->delete();
        $this->view->setVars([
            'data' => $data
        ]);
    }

    public function updateAction($id){
        $model = \seriesOfLetters::findFirst("id=$id AND project_id ={$this->session->get('project-id')} ");
        if( $this->request->isPost() )
        {


            $data['project_id']     = $this->session->get('project-id');
            $data['name']           = $this->request->getPost('name', 'string', NULL );
            $data['status']         = $this->request->getPost('status')?$this->request->getPost('status'):0 ;
            $data['event']          = $this->request->getPost('event' );
            $data['period_val']     = $this->request->getPost('period_val' );
            $data['first_delivery'] = $this->request->getPost('first_delivery' );
            $data['letters']        = implode(',',$data['event']);

            if( !empty( $data['name'] ))
            {
                if( $model->save( $data ) )
                {
                    $this->flash->success( 'Сохранение прошло успешно' );
                    return $this->response->redirect('series_of_letters/index');
                }
                else
                {
                    $this->flash->error( 'Произошла ошибка во время добавления.' );
                }
            }
        }


        $events = \eventEmail::find("id IN ('".implode("','", explode(',',$model->letters))."') ");
        $this->view->pick( 'series_of_letters/addEdit' );
        $this->view->setVars([
            'page' => $model,
            'events' => $events
        ]);
    }

    public function getTemplateAction()
    {
        $this->view->setTemplateAfter('none');
        $like = $this->request->getPost('like', 'string', NULL );
        $users = \eventEmail::find(array(
            "name LIKE '%$like%' AND project_id = {$this->session->get('project-id')}"
        ));
        $result = json_encode($users->toArray());
        $this->view->disableLevel(\Phalcon\Mvc\View::LEVEL_MAIN_LAYOUT);
        echo $result;
    }
}